import crypto from 'node:crypto';

//
export function createChain(chain = []) {
        return {
                createBlock: function (data = {}) {
                        chain.push({
                                data,
                                hash: crypto.createHash('md5')
                                        .update((chain.length <= 0) ?
                                                '{}' :
                                                JSON.stringify(chain[chain.length - 1])
                                        )
                                        .digest('base64'),
                                timestamp: Date.now()
                        });
                },
                exportChain: function () {
                        return chain;
                },
                validateChain: function () {
                        let valid = true;
                        for (let i = chain.length; i--;) {
                                if (i === 0) break;
                                if (crypto.createHash('md5')
                                        .update(JSON.stringify(chain[i - 1]))
                                        .digest('base64') !== chain[i].hash
                                ) {
                                        valid = false;
                                };
                        };
                
                        //
                        return valid;
                }
        };
};

//
export default {
        createChain
};
