export function parse(cookie = '') {
        const parsedCookie = {};
        const variables = cookie.replace(/\s/g, '').split(';');

        // Checks all of the variables and saves them if they are valid.
        for (const variable of variables) {
                const [ key, value ] = variable.split('=');

                // Ensures the key and value are not malformed.
                if (
                        key === undefined ||
                        key === '' ||
                        value === undefined ||
                        parsedCookie[key] !== undefined
                ) {
                        continue;
                };

                // Use the key-value pair as it is legit.
                parsedCookie[key] = value;
        };

        return parsedCookie;
};

export default { parse };
