import * as http2 from 'http2';
export function createSecureServer(options = {}, port = 443, address = '0.0.0.0') {
        const stack = [];
        http2.createSecureServer(options).on('stream', function (stream, headers) {
                stream.on('error', function (error) {
                        console.log(`Handled error: ${error}`)
                });
                const method = headers[':method'];
                const path = headers[':path'];
                const domain = headers[':authority'].split('.');
                domain.pop();
                domain.pop();
                const subdomain = domain.join('.');
                for (const route of stack) {
                        if (
                                (
                                        route.subdomains === undefined ||
                                        route.subdomains.includes(subdomain)
                                ) && (
                                        route.methods === undefined ||
                                        route.methods.includes(method)
                                )
                        ) {
                                if (
                                        (
                                                route.subdirectories === undefined ||
                                                route.subdirectories === false
                                        ) &&
                                        route.path === path
                                ) {
                                        route.callback(stream, headers);
                                        break;
                                };
                                if (
                                        route.subdirectories === true &&
                                        path.startsWith(route.path)
                                ) {
                                        route.callback(stream, headers);
                                        break;
                                };
                        };
                };
                return;
        }).on('sessionError', function (error) {
                console.log(`Handled error: ${error}`);
        }).listen(port, address);
        return {
                createRoute: function ({ methods, path, subdirectories, subdomains, }, callback) {
                        stack.push({ callback, methods, path, subdirectories, subdomains, });
                }
        };
};
