import http from 'node:http';

export function handle(request = http.IncomingMessage) {
        return new Promise(function (resolve, reject) {
                // Initializes an object to buffer any data received from the client.
                let bufferedData = [];

                // Buffers all data received from the client.
                request.on('data', function (newData) {
                        bufferedData.push(newData);
                });

                // Parses all the data received from the client and resolved the promise.
                request.on('end', function () {
                        const parameters = {};

                        //
                        try {
                                // Parses the parameters of the data received from the client.
                                /*console.log();
                                for (const parameter of JSON.parse(
                                        Buffer.concat(bufferedData).toString()
                                )) {
                                        const [
                                                key,
                                                value
                                        ] = parameter.split('=');

                                        // Ensures the key and value are not malformed.
                                        if (
                                                key === undefined ||
                                                key === '' ||
                                                value === undefined ||
                                                parameters[key] !== undefined
                                        ) {
                                                continue;
                                        };

                                        // Use the key-value pair as it is legit.
                                        parameters[key] = value;
                                };*/

                                // Resolves the promise with the finalized parameters.
                                resolve(JSON.parse(Buffer.concat(bufferedData).toString()));
                        } catch (error) {
                                reject(error);
                        };
                });
        });
};

export default { handle };
