import readline from 'node:readline';

//
function createCommandLineInterface(
        input = process.stdin,
        output = process.stdout,
        prompt = ''
) {
        //
        const commands = {};

        //
        const readlineInterface = readline.promises.createInterface(input, output);
        readlineInterface.setPrompt(prompt);

        //
        output.write(prompt);

        //
        readlineInterface.on('line', function (input) {
                commands?.[input.split(' ')[0].toLowerCase()]?.callback(input.split(' ').slice(1));
                output.write(`\n${prompt}`);
        });

        //
        return {
                commands,
                createCommand: function (
                        identifier = '',
                        description = '',
                        callback = function (commandArguments = []) {}
                ) {
                        commands[identifier.toLowerCase()] = {
                                callback,
                                description
                        };
                },
                deleteCommand: function (
                        identifier = ''
                ) {
                        delete commands[identifier.toLowerCase()];
                }
        };
};

//
export default {
        createCommandLineInterface
};
