import https from 'node:https';

export function get(
    {
        headers = {},
        host = '127.0.0.1',
        port = 80,
        path = '/'
    }
) {
    return new Promise(function (
        resolve,
        reject
    ) {
        const request = https.request({
            headers,
            host,
            method: 'get',
            path,
            port,
        }, function (response) {
            const buffer = [];
        
            // Pushes all chunks of data to the buffer.
            response.on('data', function (chunk) {
                buffer.push(chunk);
            });
        
            // Reads all of the buffered data once it is finished.
            response.on('end', function () {
                resolve({
                    data: JSON.parse(buffer.join('')),
                    headers: response.headers,
                    statusCode: response.statusCode
                });
            });

            // Handles any errors.
            response.on('error', reject);
        });

        request.end();
    });
};

//
export function post(
    data = {},
    {
        headers = {},
        host = '127.0.0.1',
        port = 80,
        path = '/'
    }
) {
    console.log(data);
    return new Promise(function (
        resolve,
        reject
    ) {
        const request = https.request({
            headers,
            host,
            method: 'post',
            path,
            port,
        }, function (response) {
            const buffer = [];
        
            // Pushes all chunks of data to the buffer.
            response.on('data', function (chunk) {
                buffer.push(chunk);
            });
        
            // Reads all of the buffered data once it is finished.
            response.on('end', function () {
                console.log(buffer);
                resolve({
                    data: JSON.parse(buffer.join('')),
                    headers: response.headers,
                    statusCode: response.statusCode
                });
            });

            // Handles any errors.
            response.on('error', reject);
        });

        //
        request.write(JSON.stringify(data));
        request.end();
    });
};

export default {
    get,
    post
};
