//
import crypto from 'node:crypto';
import net from 'node:net';

//
const negotiationTypes = {
        rsa: 0,
        aes: 1,
        json: 2
};

// 
export function createServer({
        address = '0.0.0.0',
        port = 80
}) {
        const server = net.createServer();

        //
        server.on('connection', function (socket) {
                // Creates a buffer for buffering new data.
                let bufferedData = Buffer.allocUnsafe(0);

                //
                let sharedSymmetricKey = null;
                let clientAsymmetricPublicKey = null;
                let serverAsymmetricPrivateKey = null;

                // Sets the current status of the connection.
                let negotiating = 0;

                // Handles data from the client. Breaks if it is not JSON.
                socket.on('data', function (newData) {
                        // Buffers new data.
                        bufferedData = Buffer.concat([bufferedData, newData]);

                        // Handle the negotiation for stream setup.
                        if (
                                negotiating &&
                                bufferedData.length >= 1
                        ) {
                                const negotiationType = bufferedData.readUint8();

                                //
                                if (
                                        negotiationType === negotiationTypes.rsa &&
                                        bufferedData.length >= 4
                                ) {
                                        const clientAsymmetricPublicKeyLength = bufferedData.readUint16BE(1);
                                        bufferedData = bufferedData.subarray(3 + clientAsymmetricPublicKeyLength);

                                        // 
                                        clientAsymmetricPublicKey = crypto.createPublicKey(bufferedData.subarray(3, 3 + clientAsymmetricPublicKeyLength));
                                        return;
                                };

                                // Desired AES strength.

                                // Swap to data stream.
                                return;
                        };
                });
        });
};
